#include <acknex.h> // include for Pure Mode
#include <default.c> // default key functions

// defines
#define playerRotSpeed 0.5;

// variables
VECTOR tempCamRot; // stores camera rotation
VECTOR playerRot; // stores player rotation

var curHeading; // stores rotation from keys to camera
var movePressed = 0;

VECTOR ANG_LERP_VEC; // calculation vector
VECTOR vecTemp; // temp rotational vector

var animatePlayer = 0; // animation storage

// protoypes

// startup function
function main() {
	// initialise vectors
	vec_set(ANG_LERP_VEC, nullvector);
	
	level_load("level_01.wmb");
	wait(5);
	
	// cameraBasedMovement();
}

// RUDI vector update script (awesome!)
// this has been copied/pasted and used with HeelX's (christian behrenberg) permission
VECTOR* ang_lerp (VECTOR* resultVec, VECTOR* srcVec, VECTOR* destVec, var blendFactor)
{
	vec_set(resultVec, srcVec);						// Copy source into result
	vec_diff(ANG_LERP_VEC, destVec, resultVec);  // Difference vector

	ANG_LERP_VEC.x = ang(ANG_LERP_VEC.x);			// Adjust angle validity
	ANG_LERP_VEC.y = ang(ANG_LERP_VEC.y);
	ANG_LERP_VEC.z = ang(ANG_LERP_VEC.z);

	vec_scale(ANG_LERP_VEC.x, blendFactor);		// Interpolate the rotation
	vec_add(resultVec, ANG_LERP_VEC);				// Apply interpolated angle

	return(resultVec);									// Return result angle
}
// end of copy/paste

// get keys input
function getInput() {
	movePressed = 0;
	
	if(key_w | key_s | key_a | key_d) { // if any movement key is pressed...
		vec_set(vecTemp, vector(key_w - key_s, key_a - key_d, 0)); // store movement
		vec_to_angle(vecTemp, vecTemp);
		
		curHeading = vecTemp.x;
		movePressed = 1;
	}
}

// movement based on camera rotation
function cameraBasedMovement() { // WED placed <- again... sucks!
	while(1) {
		vec_set(playerRot, camera.pan); // get camera rotation
		
		getInput();
		
		vec_set(tempCamRot, my.pan); // store current rotation
		vec_add(playerRot, curHeading); // add keyheading press to the player rotation
		
		ang_lerp(my.pan, my.pan, playerRot, 0.65 * time_step); // smoothly update rotation
		my.tilt = tempCamRot.y; my.roll = tempCamRot.z; // kill tilt and roll rotation
		
		if(movePressed) {
			c_move(my, vector(10*time_step,0,0), nullvector, GLIDE); // Move when key is pressed
		}
		
		// animate, woooohooooeeiii!!
		// ugly solution, replace this with smoothing ASAP!
		if(movePressed) {
			ent_animate(my, "run", animatePlayer, ANM_CYCLE); // if moving, animate walk
		} else {
			ent_animate(my, "stand", animatePlayer, ANM_CYCLE); // else animate stand
		}
		
		animatePlayer += 5*time_step; // update animation cycle
		animatePlayer = cycle(animatePlayer, 0, 100); // cycle animation variable
		
		wait(1);
	}
}